000010*$CALL
000020*@S                      SUBROUTINE
000030 IDENTIFICATION DIVISION.
000040*                         : I-O subroutine for ISAM
000050*                         : This is an instructional example which
000060*                         : you are free to use as you see fit
000070*                         : at your own risk.  If something goes
000080*                         : wrong its not our fault, even if you
000090*                         : say it is, because we accept no
000100*                         : responsibility for loss or damages.
000110*                         : It must be something YOU did.
000120 PROGRAM-ID. FILEIO.
000130 DATE-COMPILED.
000140*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000150 ENVIRONMENT DIVISION.
000160*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000170 CONFIGURATION SECTION.
000180 SOURCE-COMPUTER. IBM-PC.
000190 OBJECT-COMPUTER. IBM-PC.
000200*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000210 INPUT-OUTPUT SECTION.
000220*                         : This section may need reconfiguring
000230*                         : for some compilers.
000240 FILE-CONTROL.
000250*
000260     SELECT DATA-FILE ASSIGN TO VARYING DATA-FILE-SPEC
000270         ORGANIZATION IS INDEXED
000280         ACCESS MODE IS DYNAMIC
000290         RECORD KEY IS FD-KEY
000300         LOCK MODE IS MANUAL
000310         FILE STATUS IS FILE-STAT.
000320*
000330*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000340 DATA DIVISION.
000350*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000360 FILE SECTION.
000370*                         : This section may need reconfiguring
000380*                         : for some compilers.
000390 FD  DATA-FILE
000400         LABEL RECORDS STANDARD.
000410* -====-
000420*                         : This subroutine does not care about
000430*                         : the structure of the file or any data
000440*                         : names in it.  All it needs to know
000450*                         : is the record length over all, and the
000460*                         : key size and position.
000470*                         : So keep this FD record simple.
000480*
000490*                         : RECORD AND KEY SIZES ARE EXAMPLES ONLY
000500*                         : --Adjust to your needs --
000510 01  FD-REC.
000520     05  FD-KEY                       PIC X(20).
000530     05  FD-FILLER                    PIC X(1480).
000540*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000550 WORKING-STORAGE SECTION.
000560 01  V--VERSION-LEVEL                 PIC 9(3) VALUE 1.
000570*
000580*                         : THIS IS THE ACTUAL FILE NAME AND
000590*                         : EXTENSION.  Adjust as needed..
000600*                         : DO NOT USE EMBEDDED SPACES IN THIS
000610*                         : NAME.
000620 01  MY-DATA-FILE-NAME                PIC X(20) VALUE
000630                                                   'DATAFILE.DAT'.
000640*
000650 01  DATA-FILE-SPEC                   PIC X(161).
000660 01  FILE-STAT                        PIC XX.
000670*
000680 01  1HUNDRED                         PIC 9(4)V9(14) VALUE 100.0.
000690*
000700*                         :---------------------------------------
000710* ------------------------: Note regarding these calculation flds.
000720*                         : There is high-order truncation
000730*                         : possible when moving a comp field
000740*                         : to a display field of equal size
000750*                         : because the comp field can hold more
000760*                         : than its picture size shows.
000770*                         : Example: 9(4) COMP-4 can hold 32k.
000780*                         :
000790*                         : Therefore we only use the comp fields
000800*                         : for the conversion from characters to
000810*                         : a number, and then move that number to
000820*                         : a display field which is one order of
000830*                         : magnitude larger: 9(4) vs 9(3) etc.
000840*                         : This prevents the high order overflow.
000850*                         :
000860*                         : You might be tempted to think you
000870*                         : could use comp all the way thru. But
000880*                         : A compiler bug (or something) also
000890*                         : crops up with very small numbers in
000900*                         : some compilers.
000910*                         : You can not put 0.000002259 into a
000920*                         : PIC 9(3)V9(15) COMP-4  field because
000930*                         : the some compilers lose the decimal
000940*                         : location.
000950*                         :---------------------------------------
000960 01  LOWEST-KEY                       PIC 9(4)V9(14).
000970 01  HIGHEST-KEY                      PIC 9(4)V9(14).
000980 01  KEY-RANGE                        PIC 9(4)V9(14).
000990 01  WRK-TARGET-KEY                   PIC 9(4)V9(14).
001000*
001010 01  CONVERT-KEY-X.
001020     05  CONVERT-KEY                  PIC 9(3)V9(15) COMP-4.
001030*
001040 01  STATUS-BYTE                      PIC X VALUE 'C'.
001050     88  IS-OPEN                      VALUE 'O'.
001060     88  NOT-OPEN                     VALUE 'C'.
001070*
001080*                         :
001090 01  WS-IDX                           PIC S9(4) COMP-5.
001100*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
001110 LINKAGE SECTION.
001120* -====-
001130         COPY FILEREQU.
001140*
001150*                         : RECORD AND KEY SIZES ARE EXAMPLES ONLY
001160*                         : --Adjust to your needs --
001170 01  LINKAGE-DATA-RECORD.
001180     05  LINKAGE-KEY                  PIC X(20).
001190     05  LINKAGE-FILLER               PIC X(1480).
001200*
001210*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
001220 PROCEDURE DIVISION USING FILE-REQUEST LINKAGE-DATA-RECORD.
001230*
001240* -====-
001250 0001-MAIN-LINE-LOGIC.
001260*
001270     EVALUATE TRUE
001280       WHEN FILE-OPEN-INPUT
001290         IF IS-OPEN
001300           CLOSE DATA-FILE
001310           SET NOT-OPEN TO TRUE
001320         END-IF
001330         PERFORM 0002-BUILD-FILE-SPEC
001340         OPEN INPUT DATA-FILE
001350         MOVE FILE-STAT TO FILE-STATUS-RETURN
001360         IF FILE-STATUS-OK
001370           SET IS-OPEN TO TRUE
001380           PERFORM 0003-GET-HIGHEST-LOWEST
001390         END-IF
001400*
001410       WHEN FILE-OPEN-OUTPUT
001420         IF IS-OPEN
001430           CLOSE DATA-FILE
001440           SET NOT-OPEN TO TRUE
001450         END-IF
001460         PERFORM 0002-BUILD-FILE-SPEC
001470         OPEN OUTPUT DATA-FILE
001480         MOVE FILE-STAT TO FILE-STATUS-RETURN
001490         IF FILE-STATUS-OK
001500           SET IS-OPEN TO TRUE
001510         END-IF
001520*
001530       WHEN FILE-OPEN-IO
001540         IF IS-OPEN
001550           CLOSE DATA-FILE
001560           SET NOT-OPEN TO TRUE
001570         END-IF
001580         PERFORM 0002-BUILD-FILE-SPEC
001590         OPEN I-O DATA-FILE
001600         MOVE FILE-STAT TO FILE-STATUS-RETURN
001610         IF FILE-STATUS-OK
001620           SET IS-OPEN TO TRUE
001630           PERFORM 0003-GET-HIGHEST-LOWEST
001640         END-IF
001650*
001660       WHEN FILE-CLOSE
001670         IF IS-OPEN
001680           CLOSE DATA-FILE
001690           SET NOT-OPEN TO TRUE
001700         END-IF
001710*
001720       WHEN FILE-READ
001730         MOVE LINKAGE-KEY TO FD-KEY
001740         READ DATA-FILE KEY IS FD-KEY
001750         MOVE FD-REC TO LINKAGE-DATA-RECORD
001760         MOVE FILE-STAT TO FILE-STATUS-RETURN
001770         PERFORM 0004-CALCULATE-PERCENT
001780*
001790       WHEN FILE-READ-LOCK
001800         MOVE LINKAGE-KEY TO FD-KEY
001810         READ DATA-FILE WITH LOCK
001820             KEY IS FD-KEY
001830         MOVE FD-REC TO LINKAGE-DATA-RECORD
001840         MOVE FILE-STAT TO FILE-STATUS-RETURN
001850         PERFORM 0004-CALCULATE-PERCENT
001860*
001870       WHEN FILE-UNLOCK
001880         MOVE LINKAGE-KEY TO FD-KEY
001890         UNLOCK DATA-FILE
001900*
001910       WHEN FILE-READ-NEXT
001920         READ DATA-FILE
001930         NEXT RECORD
001940         MOVE FD-REC TO LINKAGE-DATA-RECORD
001950         MOVE FILE-STAT TO FILE-STATUS-RETURN
001960         PERFORM 0004-CALCULATE-PERCENT
001970*
001980       WHEN FILE-READ-PRIOR
001990         READ DATA-FILE PRIOR RECORD
002000         MOVE FD-REC TO LINKAGE-DATA-RECORD
002010         MOVE FILE-STAT TO FILE-STATUS-RETURN
002020         PERFORM 0004-CALCULATE-PERCENT
002030*
002040       WHEN FILE-WRITE
002050         MOVE LINKAGE-DATA-RECORD TO FD-REC
002060         WRITE FD-REC
002070         MOVE FILE-STAT TO FILE-STATUS-RETURN
002080         PERFORM 0003-GET-HIGHEST-LOWEST
002090*
002100       WHEN FILE-REWRITE
002110         MOVE LINKAGE-DATA-RECORD TO FD-REC
002120         REWRITE FD-REC
002130         MOVE FILE-STAT TO FILE-STATUS-RETURN
002140*
002150       WHEN FILE-DELETE
002160         MOVE LINKAGE-DATA-RECORD TO FD-REC
002170         DELETE DATA-FILE RECORD
002180         MOVE FILE-STAT TO FILE-STATUS-RETURN
002190         PERFORM 0003-GET-HIGHEST-LOWEST
002200*
002210       WHEN FILE-START-EQUAL
002220         MOVE LINKAGE-DATA-RECORD TO FD-REC
002230         START DATA-FILE KEY IS EQUAL TO FD-KEY
002240         MOVE FILE-STAT TO FILE-STATUS-RETURN
002250*
002260       WHEN FILE-START-NOT-LESS
002270         MOVE LINKAGE-DATA-RECORD TO FD-REC
002280         START DATA-FILE KEY IS NOT LESS THAN FD-KEY
002290         MOVE FILE-STAT TO FILE-STATUS-RETURN
002300*
002310       WHEN FILE-START-GREATER
002320         MOVE LINKAGE-DATA-RECORD TO FD-REC
002330         START DATA-FILE KEY IS GREATER THAN FD-KEY
002340         MOVE FILE-STAT TO FILE-STATUS-RETURN
002350*
002360       WHEN FILE-START-AT-PERCENT
002370*                         : Calculate the NEEDED key...
002380*                         : its x percent of the range plus
002390*                         : the lowest key.
002400         COMPUTE CONVERT-KEY =
002410             ( (FILE-PERCENT / 1HUNDRED) * KEY-RANGE) + LOWEST-KEY
002420*
002430         MOVE CONVERT-KEY-X TO FD-KEY
002440         START DATA-FILE KEY IS NOT LESS THAN FD-KEY
002450         MOVE FILE-STAT TO FILE-STATUS-RETURN
002460*
002470     END-EVALUATE
002480     GOBACK.
002490*
002500 0002-BUILD-FILE-SPEC.
002510*                         : This method of supplying a variable
002520*                         : file spec is CA-Realia Specific.
002530*                         : You may need to change this paragraph.
002540     MOVE FILE-PATH-SPEC TO DATA-FILE-SPEC
002550     PERFORM
002560           VARYING WS-IDX FROM LENGTH OF DATA-FILE-SPEC BY -1
002570           UNTIL WS-IDX NOT > 0
002580           OR DATA-FILE-SPEC (WS-IDX:1) > SPACE
002590       MOVE LOW-VALUE TO DATA-FILE-SPEC (WS-IDX:1)
002600     END-PERFORM.
002610*                         : Now point to first low-value
002620     ADD 1 TO WS-IDX
002630     STRING MY-DATA-FILE-NAME DELIMITED SPACE
002640         '[X:B4:D2:I4]' LOW-VALUE DELIMITED SIZE
002650          INTO DATA-FILE-SPEC WITH POINTER WS-IDX.
002660*
002670 0003-GET-HIGHEST-LOWEST.
002680     MOVE ZERO TO KEY-RANGE.
002690*                         : First get the lowest actual key
002700     MOVE LOW-VALUES TO FD-REC
002710     START DATA-FILE KEY IS GREATER THAN FD-KEY
002720*
002730     READ DATA-FILE
002740     NEXT RECORD
002750     IF FILE-STAT = '00'
002760       MOVE FD-KEY TO CONVERT-KEY-X
002770       MOVE CONVERT-KEY TO LOWEST-KEY
002780*                         : now get the highest key
002790       MOVE HIGH-VALUES TO FD-REC
002800       START DATA-FILE KEY IS GREATER THAN FD-KEY
002810*                         : We know the above will yield eof
002820       READ DATA-FILE PRIOR RECORD
002830       IF FILE-STAT = '00'
002840         MOVE FD-KEY TO CONVERT-KEY-X
002850         MOVE CONVERT-KEY TO HIGHEST-KEY
002860         SUBTRACT LOWEST-KEY FROM HIGHEST-KEY
002870             GIVING KEY-RANGE.
002880*
002890 0004-CALCULATE-PERCENT.
002900*                         : This calcs the % value of the key
002910*                         : for the record just read in
002920     MOVE ZERO TO FILE-PERCENT.
002930     IF KEY-RANGE > ZERO
002940       MOVE FD-KEY TO CONVERT-KEY-X
002950       MOVE CONVERT-KEY TO WRK-TARGET-KEY
002960       SUBTRACT LOWEST-KEY FROM WRK-TARGET-KEY
002970       DIVIDE WRK-TARGET-KEY BY KEY-RANGE GIVING WRK-TARGET-KEY
002980       MULTIPLY 1HUNDRED BY WRK-TARGET-KEY GIVING FILE-PERCENT.
002990*
